git-rebase.shon commit Merge branch 'maint' (2515f93)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        cmt=`cat "$dotest/current"`
  63        if ! git diff-index --quiet HEAD
  64        then
  65                if ! git-commit -C "$cmt"
  66                then
  67                        echo "Commit failed, please do not call \"git commit\""
  68                        echo "directly, but instead do one of the following: "
  69                        die "$RESOLVEMSG"
  70                fi
  71                printf "Committed: %0${prec}d " $msgnum
  72        else
  73                printf "Already applied: %0${prec}d " $msgnum
  74        fi
  75        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat "$dotest/cmt.$1")"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD)
  91        msgnum=$(cat "$dotest/msgnum")
  92        end=$(cat "$dotest/end")
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        rm -r "$dotest"
 120        echo "All done."
 121}
 122
 123is_interactive () {
 124        test -f "$dotest"/interactive ||
 125        while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 126                shift
 127        done && test -n "$1"
 128}
 129
 130is_interactive "$@" && exec git-rebase--interactive "$@"
 131
 132while test $# != 0
 133do
 134        case "$1" in
 135        --continue)
 136                git diff-files --quiet || {
 137                        echo "You must edit all merge conflicts and then"
 138                        echo "mark them as resolved using git add"
 139                        exit 1
 140                }
 141                if test -d "$dotest"
 142                then
 143                        prev_head=$(cat "$dotest/prev_head")
 144                        end=$(cat "$dotest/end")
 145                        msgnum=$(cat "$dotest/msgnum")
 146                        onto=$(cat "$dotest/onto")
 147                        continue_merge
 148                        while test "$msgnum" -le "$end"
 149                        do
 150                                call_merge "$msgnum"
 151                                continue_merge
 152                        done
 153                        finish_rb_merge
 154                        exit
 155                fi
 156                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 157                exit
 158                ;;
 159        --skip)
 160                if test -d "$dotest"
 161                then
 162                        git rerere clear
 163                        prev_head=$(cat "$dotest/prev_head")
 164                        end=$(cat "$dotest/end")
 165                        msgnum=$(cat "$dotest/msgnum")
 166                        msgnum=$(($msgnum + 1))
 167                        onto=$(cat "$dotest/onto")
 168                        while test "$msgnum" -le "$end"
 169                        do
 170                                call_merge "$msgnum"
 171                                continue_merge
 172                        done
 173                        finish_rb_merge
 174                        exit
 175                fi
 176                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 177                exit
 178                ;;
 179        --abort)
 180                git rerere clear
 181                if test -d "$dotest"
 182                then
 183                        rm -r "$dotest"
 184                elif test -d .dotest
 185                then
 186                        rm -r .dotest
 187                else
 188                        die "No rebase in progress?"
 189                fi
 190                git reset --hard ORIG_HEAD
 191                exit
 192                ;;
 193        --onto)
 194                test 2 -le "$#" || usage
 195                newbase="$2"
 196                shift
 197                ;;
 198        -M|-m|--m|--me|--mer|--merg|--merge)
 199                do_merge=t
 200                ;;
 201        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 202                --strateg=*|--strategy=*|\
 203        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 204                case "$#,$1" in
 205                *,*=*)
 206                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 207                1,*)
 208                        usage ;;
 209                *)
 210                        strategy="$2"
 211                        shift ;;
 212                esac
 213                do_merge=t
 214                ;;
 215        -v|--verbose)
 216                verbose=t
 217                ;;
 218        --whitespace=*)
 219                git_am_opt="$git_am_opt $1"
 220                ;;
 221        -C*)
 222                git_am_opt="$git_am_opt $1"
 223                ;;
 224        -*)
 225                usage
 226                ;;
 227        *)
 228                break
 229                ;;
 230        esac
 231        shift
 232done
 233
 234# Make sure we do not have .dotest
 235if test -z "$do_merge"
 236then
 237        if mkdir .dotest
 238        then
 239                rmdir .dotest
 240        else
 241                echo >&2 '
 242It seems that I cannot create a .dotest directory, and I wonder if you
 243are in the middle of patch application or another rebase.  If that is not
 244the case, please rm -fr .dotest and run me again.  I am stopping in case
 245you still have something valuable there.'
 246                exit 1
 247        fi
 248else
 249        if test -d "$dotest"
 250        then
 251                die "previous dotest directory $dotest still exists." \
 252                        'try git-rebase < --continue | --abort >'
 253        fi
 254fi
 255
 256# The tree must be really really clean.
 257git update-index --refresh || exit
 258diff=$(git diff-index --cached --name-status -r HEAD)
 259case "$diff" in
 260?*)     echo "cannot rebase: your index is not up-to-date"
 261        echo "$diff"
 262        exit 1
 263        ;;
 264esac
 265
 266# The upstream head must be given.  Make sure it is valid.
 267upstream_name="$1"
 268upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 269    die "invalid upstream $upstream_name"
 270
 271# Make sure the branch to rebase onto is valid.
 272onto_name=${newbase-"$upstream_name"}
 273onto=$(git rev-parse --verify "${onto_name}^0") || exit
 274
 275# If a hook exists, give it a chance to interrupt
 276if test -x "$GIT_DIR/hooks/pre-rebase"
 277then
 278        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 279                echo >&2 "The pre-rebase hook refused to rebase."
 280                exit 1
 281        }
 282fi
 283
 284# If the branch to rebase is given, first switch to it.
 285case "$#" in
 2862)
 287        branch_name="$2"
 288        git-checkout "$2" || usage
 289        ;;
 290*)
 291        if branch_name=`git symbolic-ref -q HEAD`
 292        then
 293                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 294        else
 295                branch_name=HEAD ;# detached
 296        fi
 297        ;;
 298esac
 299branch=$(git rev-parse --verify "${branch_name}^0") || exit
 300
 301# Now we are rebasing commits $upstream..$branch on top of $onto
 302
 303# Check if we are already based on $onto with linear history,
 304# but this should be done only when upstream and onto are the same.
 305mb=$(git merge-base "$onto" "$branch")
 306if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 307        # linear history?
 308        ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
 309then
 310        echo >&2 "Current branch $branch_name is up to date."
 311        exit 0
 312fi
 313
 314if test -n "$verbose"
 315then
 316        echo "Changes from $mb to $onto:"
 317        # We want color (if set), but no pager
 318        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 319fi
 320
 321# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 322echo "First, rewinding head to replay your work on top of it..."
 323git-reset --hard "$onto"
 324
 325# If the $onto is a proper descendant of the tip of the branch, then
 326# we just fast forwarded.
 327if test "$mb" = "$branch"
 328then
 329        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 330        exit 0
 331fi
 332
 333if test -z "$do_merge"
 334then
 335        git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 336        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 337        exit $?
 338fi
 339
 340# start doing a rebase with git-merge
 341# this is rename-aware if the recursive (default) strategy is used
 342
 343mkdir -p "$dotest"
 344echo "$onto" > "$dotest/onto"
 345echo "$onto_name" > "$dotest/onto_name"
 346prev_head=`git rev-parse HEAD^0`
 347echo "$prev_head" > "$dotest/prev_head"
 348
 349msgnum=0
 350for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
 351do
 352        msgnum=$(($msgnum + 1))
 353        echo "$cmt" > "$dotest/cmt.$msgnum"
 354done
 355
 356echo 1 >"$dotest/msgnum"
 357echo $msgnum >"$dotest/end"
 358
 359end=$msgnum
 360msgnum=1
 361
 362while test "$msgnum" -le "$end"
 363do
 364        call_merge "$msgnum"
 365        continue_merge
 366done
 367
 368finish_rb_merge